Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ICC_Profile.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ICC_Profile.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/ICC_Profile.pm	(revision 34921)
@@ -11,4 +11,5 @@
 #               4) http://www.color.org/privatetag2007-01.pdf
 #               5) http://www.color.org/icc_specs2.xalter (approved revisions, 2010-07-16)
+#               6) Eef Vreeland private communication
 #
 # Notes:        The ICC profile information is different: the format of each
@@ -24,5 +25,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.22';
+$VERSION = '1.36';
 
 sub ProcessICC($$);
@@ -53,4 +54,281 @@
     nkpf => 'Nikon Input Device Profile (NON-STANDARD!)', # (written by Nikon utilities)
 );
+my %manuSig = ( #6
+    'NONE' => 'none',
+    'none' => 'none', #PH
+    ''     => '', #PH
+    '4d2p' => 'Erdt Systems GmbH & Co KG',
+    'AAMA' => 'Aamazing Technologies, Inc.',
+    'ACER' => 'Acer Peripherals',
+    'ACLT' => 'Acolyte Color Research',
+    'ACTI' => 'Actix Systems, Inc.',
+    'ADAR' => 'Adara Technology, Inc.',
+    'ADBE' => 'Adobe Systems Inc.',
+    'ADI ' => 'ADI Systems, Inc.',
+    'AGFA' => 'Agfa Graphics N.V.',
+    'ALMD' => 'Alps Electric USA, Inc.',
+    'ALPS' => 'Alps Electric USA, Inc.',
+    'ALWN' => 'Alwan Color Expertise',
+    'AMTI' => 'Amiable Technologies, Inc.',
+    'AOC ' => 'AOC International (U.S.A), Ltd.',
+    'APAG' => 'Apago',
+    'APPL' => 'Apple Computer Inc.',
+    'appl' => 'Apple Computer Inc.',
+    'AST ' => 'AST',
+    'AT&T' => 'AT&T Computer Systems',
+    'BAEL' => 'BARBIERI electronic',
+    'berg' => 'bergdesign incorporated',
+    'bICC' => 'basICColor GmbH',
+    'BRCO' => 'Barco NV',
+    'BRKP' => 'Breakpoint Pty Limited',
+    'BROT' => 'Brother Industries, LTD',
+    'BULL' => 'Bull',
+    'BUS ' => 'Bus Computer Systems',
+    'C-IT' => 'C-Itoh',
+    'CAMR' => 'Intel Corporation',
+    'CANO' => 'Canon, Inc. (Canon Development Americas, Inc.)',
+    'CARR' => 'Carroll Touch',
+    'CASI' => 'Casio Computer Co., Ltd.',
+    'CBUS' => 'Colorbus PL',
+    'CEL ' => 'Crossfield',
+    'CELx' => 'Crossfield',
+    'ceyd' => 'Integrated Color Solutions, Inc.',
+    'CGS ' => 'CGS Publishing Technologies International GmbH',
+    'CHM ' => 'Rochester Robotics',
+    'CIGL' => 'Colour Imaging Group, London',
+    'CITI' => 'Citizen',
+    'CL00' => 'Candela, Ltd.',
+    'CLIQ' => 'Color IQ',
+    'clsp' => 'MacDermid ColorSpan, Inc.',
+    'CMCO' => 'Chromaco, Inc.',
+    'CMiX' => 'CHROMiX',
+    'COLO' => 'Colorgraphic Communications Corporation',
+    'COMP' => 'COMPAQ Computer Corporation',
+    'COMp' => 'Compeq USA/Focus Technology',
+    'CONR' => 'Conrac Display Products',
+    'CORD' => 'Cordata Technologies, Inc.',
+    'CPQ ' => 'Compaq Computer Corporation',
+    'CPRO' => 'ColorPro',
+    'CRN ' => 'Cornerstone',
+    'CTX ' => 'CTX International, Inc.',
+    'CVIS' => 'ColorVision',
+    'CWC ' => 'Fujitsu Laboratories, Ltd.',
+    'DARI' => 'Darius Technology, Ltd.',
+    'DATA' => 'Dataproducts',
+    'DCP ' => 'Dry Creek Photo',
+    'DCRC' => 'Digital Contents Resource Center, Chung-Ang University',
+    'DELL' => 'Dell Computer Corporation',
+    'DIC ' => 'Dainippon Ink and Chemicals',
+    'DICO' => 'Diconix',
+    'DIGI' => 'Digital',
+    'DL&C' => 'Digital Light & Color',
+    'DPLG' => 'Doppelganger, LLC',
+    'DS  ' => 'Dainippon Screen',
+    'ds  ' => 'Dainippon Screen',
+    'DSOL' => 'DOOSOL',
+    'DUPN' => 'DuPont',
+    'dupn' => 'DuPont',
+    'Eizo' => 'EIZO NANAO CORPORATION',
+    'EPSO' => 'Epson',
+    'ESKO' => 'Esko-Graphics',
+    'ETRI' => 'Electronics and Telecommunications Research Institute',
+    'EVER' => 'Everex Systems, Inc.',
+    'EXAC' => 'ExactCODE GmbH',
+    'FALC' => 'Falco Data Products, Inc.',
+    'FF  ' => 'Fuji Photo Film Co.,LTD',
+    'FFEI' => 'FujiFilm Electronic Imaging, Ltd.',
+    'ffei' => 'FujiFilm Electronic Imaging, Ltd.',
+    'flux' => 'FluxData Corporation',
+    'FNRD' => 'fnord software',
+    'FORA' => 'Fora, Inc.',
+    'FORE' => 'Forefront Technology Corporation',
+    'FP  ' => 'Fujitsu',
+    'FPA ' => 'WayTech Development, Inc.',
+    'FUJI' => 'Fujitsu',
+    'FX  ' => 'Fuji Xerox Co., Ltd.',
+    'GCC ' => 'GCC Technologies, Inc.',
+    'GGSL' => 'Global Graphics Software Limited',
+    'GMB ' => 'Gretagmacbeth',
+    'GMG ' => 'GMG GmbH & Co. KG',
+    'GOLD' => 'GoldStar Technology, Inc.',
+    'GOOG' => 'Google', #PH
+    'GPRT' => 'Giantprint Pty Ltd',
+    'GTMB' => 'Gretagmacbeth',
+    'GVC ' => 'WayTech Development, Inc.',
+    'GW2K' => 'Sony Corporation',
+    'HCI ' => 'HCI',
+    'HDM ' => 'Heidelberger Druckmaschinen AG',
+    'HERM' => 'Hermes',
+    'HITA' => 'Hitachi America, Ltd.',
+    'HiTi' => 'HiTi Digital, Inc.',
+    'HP  ' => 'Hewlett-Packard',
+    'HTC ' => 'Hitachi, Ltd.',
+    'IBM ' => 'IBM Corporation',
+    'IDNT' => 'Scitex Corporation, Ltd.',
+    'Idnt' => 'Scitex Corporation, Ltd.',
+    'IEC ' => 'Hewlett-Packard',
+    'IIYA' => 'Iiyama North America, Inc.',
+    'IKEG' => 'Ikegami Electronics, Inc.',
+    'IMAG' => 'Image Systems Corporation',
+    'IMI ' => 'Ingram Micro, Inc.',
+    'Inca' => 'Inca Digital Printers Ltd.',
+    'INTC' => 'Intel Corporation',
+    'INTL' => 'N/A (INTL)',
+    'INTR' => 'Intra Electronics USA, Inc.',
+    'IOCO' => 'Iocomm International Technology Corporation',
+    'IPS ' => 'InfoPrint Solutions Company',
+    'IRIS' => 'Scitex Corporation, Ltd.',
+    'Iris' => 'Scitex Corporation, Ltd.',
+    'iris' => 'Scitex Corporation, Ltd.',
+    'ISL ' => 'Ichikawa Soft Laboratory',
+    'ITNL' => 'N/A (ITNL)',
+    'IVM ' => 'IVM',
+    'IWAT' => 'Iwatsu Electric Co., Ltd.',
+    'JPEG' => 'Joint Photographic Experts Group', #PH
+    'JSFT' => 'Jetsoft Development',
+    'JVC ' => 'JVC Information Products Co.',
+    'KART' => 'Scitex Corporation, Ltd.',
+    'Kart' => 'Scitex Corporation, Ltd.',
+    'kart' => 'Scitex Corporation, Ltd.',
+    'KFC ' => 'KFC Computek Components Corporation',
+    'KLH ' => 'KLH Computers',
+    'KMHD' => 'Konica Minolta Holdings, Inc.',
+    'KNCA' => 'Konica Corporation',
+    'KODA' => 'Kodak',
+    'KYOC' => 'Kyocera',
+    'LCAG' => 'Leica Camera AG',
+    'LCCD' => 'Leeds Colour',
+    'lcms' => 'Little CMS', #NealKrawetz
+    'LDAK' => 'Left Dakota',
+    'LEAD' => 'Leading Technology, Inc.',
+    'Leaf' => 'Leaf', #PH
+    'LEXM' => 'Lexmark International, Inc.',
+    'LINK' => 'Link Computer, Inc.',
+    'LINO' => 'Linotronic',
+    'Lino' => 'Linotronic', #PH (NC)
+    'lino' => 'Linotronic', #PH (NC)
+    'LITE' => 'Lite-On, Inc.',
+    'MAGC' => 'Mag Computronic (USA) Inc.',
+    'MAGI' => 'MAG Innovision, Inc.',
+    'MANN' => 'Mannesmann',
+    'MICN' => 'Micron Technology, Inc.',
+    'MICR' => 'Microtek',
+    'MICV' => 'Microvitec, Inc.',
+    'MINO' => 'Minolta',
+    'MITS' => 'Mitsubishi Electronics America, Inc.',
+    'MITs' => 'Mitsuba Corporation',
+    'Mits' => 'Mitsubishi Electric Corporation Kyoto Works',
+    'MNLT' => 'Minolta',
+    'MODG' => 'Modgraph, Inc.',
+    'MONI' => 'Monitronix, Inc.',
+    'MONS' => 'Monaco Systems Inc.',
+    'MORS' => 'Morse Technology, Inc.',
+    'MOTI' => 'Motive Systems',
+    'MSFT' => 'Microsoft Corporation',
+    'MUTO' => 'MUTOH INDUSTRIES LTD.',
+    'NANA' => 'NANAO USA Corporation',
+    'NEC ' => 'NEC Corporation',
+    'NEXP' => 'NexPress Solutions LLC',
+    'NISS' => 'Nissei Sangyo America, Ltd.',
+    'NKON' => 'Nikon Corporation',
+    'ob4d' => 'Erdt Systems GmbH & Co KG',
+    'obic' => 'Medigraph GmbH',
+    'OCE ' => 'Oce Technologies B.V.',
+    'OCEC' => 'OceColor',
+    'OKI ' => 'Oki',
+    'OKID' => 'Okidata',
+    'OKIP' => 'Okidata',
+    'OLIV' => 'Olivetti',
+    'OLYM' => 'OLYMPUS OPTICAL CO., LTD',
+    'ONYX' => 'Onyx Graphics',
+    'OPTI' => 'Optiquest',
+    'PACK' => 'Packard Bell',
+    'PANA' => 'Matsushita Electric Industrial Co., Ltd.',
+    'PANT' => 'Pantone, Inc.',
+    'PBN ' => 'Packard Bell',
+    'PFU ' => 'PFU Limited',
+    'PHIL' => 'Philips Consumer Electronics Co.',
+    'PNTX' => 'HOYA Corporation PENTAX Imaging Systems Division',
+    'POne' => 'Phase One A/S',
+    'PREM' => 'Premier Computer Innovations',
+    'PRIN' => 'Princeton Graphic Systems',
+    'PRIP' => 'Princeton Publishing Labs',
+    'QLUX' => 'Hong Kong',
+    'QMS ' => 'QMS, Inc.',
+    'QPCD' => 'QPcard AB',
+    'QUAD' => 'QuadLaser',
+    'quby' => 'Qubyx Sarl',
+    'QUME' => 'Qume Corporation',
+    'RADI' => 'Radius, Inc.',
+    'RDDx' => 'Integrated Color Solutions, Inc.',
+    'RDG ' => 'Roland DG Corporation',
+    'REDM' => 'REDMS Group, Inc.',
+    'RELI' => 'Relisys',
+    'RGMS' => 'Rolf Gierling Multitools',
+    'RICO' => 'Ricoh Corporation',
+    'RNLD' => 'Edmund Ronald',
+    'ROYA' => 'Royal',
+    'RPC ' => 'Ricoh Printing Systems,Ltd.',
+    'RTL ' => 'Royal Information Electronics Co., Ltd.',
+    'SAMP' => 'Sampo Corporation of America',
+    'SAMS' => 'Samsung, Inc.',
+    'SANT' => 'Jaime Santana Pomares',
+    'SCIT' => 'Scitex Corporation, Ltd.',
+    'Scit' => 'Scitex Corporation, Ltd.',
+    'scit' => 'Scitex Corporation, Ltd.',
+    'SCRN' => 'Dainippon Screen',
+    'scrn' => 'Dainippon Screen',
+    'SDP ' => 'Scitex Corporation, Ltd.',
+    'Sdp ' => 'Scitex Corporation, Ltd.',
+    'sdp ' => 'Scitex Corporation, Ltd.',
+    'SEC ' => 'SAMSUNG ELECTRONICS CO.,LTD',
+    'SEIK' => 'Seiko Instruments U.S.A., Inc.',
+    'SEIk' => 'Seikosha',
+    'SGUY' => 'ScanGuy.com',
+    'SHAR' => 'Sharp Laboratories',
+    'SICC' => 'International Color Consortium',
+    'siwi' => 'SIWI GRAFIKA CORPORATION',
+    'SONY' => 'SONY Corporation',
+    'Sony' => 'Sony Corporation',
+    'SPCL' => 'SpectraCal',
+    'STAR' => 'Star',
+    'STC ' => 'Sampo Technology Corporation',
+    'TALO' => 'Talon Technology Corporation',
+    'TAND' => 'Tandy',
+    'TATU' => 'Tatung Co. of America, Inc.',
+    'TAXA' => 'TAXAN America, Inc.',
+    'TDS ' => 'Tokyo Denshi Sekei K.K.',
+    'TECO' => 'TECO Information Systems, Inc.',
+    'TEGR' => 'Tegra',
+    'TEKT' => 'Tektronix, Inc.',
+    'TI  ' => 'Texas Instruments',
+    'TMKR' => 'TypeMaker Ltd.',
+    'TOSB' => 'TOSHIBA corp.',
+    'TOSH' => 'Toshiba, Inc.',
+    'TOTK' => 'TOTOKU ELECTRIC Co., LTD',
+    'TRIU' => 'Triumph',
+    'TSBT' => 'TOSHIBA TEC CORPORATION',
+    'TTX ' => 'TTX Computer Products, Inc.',
+    'TVM ' => 'TVM Professional Monitor Corporation',
+    'TW  ' => 'TW Casper Corporation',
+    'ULSX' => 'Ulead Systems',
+    'UNIS' => 'Unisys',
+    'UTZF' => 'Utz Fehlau & Sohn',
+    'VARI' => 'Varityper',
+    'VIEW' => 'Viewsonic',
+    'VISL' => 'Visual communication',
+    'VIVO' => 'Vivo Mobile Communication Co., Ltd',
+    'WANG' => 'Wang',
+    'WLBR' => 'Wilbur Imaging',
+    'WTG2' => 'Ware To Go',
+    'WYSE' => 'WYSE Technology',
+    'XERX' => 'Xerox Corporation',
+    'XRIT' => 'X-Rite',
+    'yxym' => 'YxyMaster GmbH',
+    'Z123' => "Lavanya's test Company",
+    'Zebr' => 'Zebra Technologies Inc',
+    'ZRAN' => 'Zoran Corporation',
+    # also seen: "    ",ACMS,KCMS,UCCM,etc2,SCTX
+);
 
 # ICC_Profile tag table
@@ -86,5 +364,5 @@
     targ => {
         Name => 'CharTarget',
-        ValueConv => 'length $val > 128 ? \$val : $val',
+        ValueConv => '$val=~s/\0.*//; length $val > 128 ? \$val : $val',
     },
     chad => 'ChromaticAdaptation',
@@ -257,4 +535,9 @@
     MS00 => 'WCSProfiles',
 
+    psd3 => { #6
+        Name => 'PostScript2CRD3',
+        Binary => 1, # (NC)
+    },
+
     # the following entry represents the ICC profile header, and doesn't
     # exist as a tag in the directory.  It is only in this table to provide
@@ -275,4 +558,6 @@
         Name => 'ProfileCMMType',
         Format => 'string[4]',
+        SeparateTable => 'ManuSig',
+        PrintConv => \%manuSig,
     },
     8 => {
@@ -327,10 +612,11 @@
         Name => 'DeviceManufacturer',
         Format => 'string[4]',
-        # KODA = Kodak
+        SeparateTable => 'ManuSig',
+        PrintConv => \%manuSig,
     },
     52 => {
         Name => 'DeviceModel',
         Format => 'string[4]',
-        # ROMM = Refrence Output Medium Metric
+        # ROMM = Reference Output Medium Metric
     },
     56 => {
@@ -362,5 +648,6 @@
         Name => 'ProfileCreator',
         Format => 'string[4]',
-        # KODA = Kodak
+        SeparateTable => 'ManuSig',
+        PrintConv => \%manuSig,
     },
     84 => {
@@ -410,4 +697,5 @@
         Format => 'int32u',
         PrintConv => {
+            0 => 'Unknown',
             1 => '0/45 or 45/0',
             2 => '0/d or d/0',
@@ -517,5 +805,5 @@
 
 #------------------------------------------------------------------------------
-# print ICC Profile ID in hex
+# Print ICC Profile ID in hex
 # Inputs: 1) string of numbers
 # Returns: string of hex digits
@@ -532,10 +820,10 @@
 
 #------------------------------------------------------------------------------
-# get formatted value from ICC tag (which has the type embedded)
+# Get formatted value from ICC tag (which has the type embedded)
 # Inputs: 0) data reference, 1) offset to tag data, 2) tag data size
 # Returns: Formatted value or undefined if format not supported
 # Notes: The following types are handled by BinaryTables:
 #  chromaticityType, colorantTableType, measurementType, viewingConditionsType
-# The following types are not currently handled (most are large tables):
+# The following types are currently not handled (most are large tables):
 #  curveType, lut16Type, lut8Type, lutAtoBType, lutBtoAType, namedColor2Type,
 #  parametricCurveType, profileSeqDescType, responseCurveSet16Type
@@ -628,18 +916,18 @@
 sub ProcessMetadata($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart};
     my $dirLen = $$dirInfo{DirLen};
     my $dirEnd = $dirStart + $dirLen;
-    
+
     if ($dirLen < 16 or substr($$dataPt, $dirStart, 4) ne 'dict') {
-        $exifTool->Warn('Invalid ICC meta dictionary');
+        $et->Warn('Invalid ICC meta dictionary');
         return 0;
     }
     my $num = Get32u($dataPt, $dirStart + 8);
-    $exifTool->VerboseDir('Metadata', $num);
+    $et->VerboseDir('Metadata', $num);
     my $size = Get32u($dataPt, $dirStart + 12);
-    $size < 16 and $exifTool->Warn('Invalid ICC meta record size'), return 0;
+    $size < 16 and $et->Warn('Invalid ICC meta record size'), return 0;
     # NOTE: In the example the minimum offset is 20,
     # but this doesn't jive with the table (both in ref 5)
@@ -649,5 +937,5 @@
         my $entry = $dirStart + 16 + $size * $index;
         if ($entry + $size > $dirEnd) {
-            $exifTool->Warn('Truncated ICC meta dictionary');
+            $et->Warn('Truncated ICC meta dictionary');
             last;
         }
@@ -660,11 +948,11 @@
             $valuePtr < $minPtr or $valuePtr + $valueLen > $dirLen)
         {
-            $exifTool->Warn('Corrupted ICC meta dictionary');
+            $et->Warn('Corrupted ICC meta dictionary');
             last;
         }
         my $tag = substr($dataPt, $dirStart + $namePtr, $nameLen);
         my $val = substr($dataPt, $dirStart + $valuePtr, $valueLen);
-        $tag = $exifTool->Decode($tag, 'UTF16', 'MM', 'UTF8');
-        $val = $exifTool->Decode($val, 'UTF16', 'MM');
+        $tag = $et->Decode($tag, 'UTF16', 'MM', 'UTF8');
+        $val = $et->Decode($val, 'UTF16', 'MM');
         # generate tagInfo if it doesn't exist
         unless ($$tagTablePtr{$tag}) {
@@ -673,7 +961,7 @@
             $name =~ tr/-_a-zA-Z0-9//dc;
             next unless length $name;
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, { Name => $name });
+            AddTagToTable($tagTablePtr, $tag, { Name => $name });
         }
-        $exifTool->HandleTag($tagTablePtr, $tag, $val);
+        $et->HandleTag($tagTablePtr, $tag, $val);
     }
     return 1;
@@ -687,5 +975,5 @@
 sub WriteICC($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     # first make sure this is a valid ICC file (or no file at all)
     my $raf = $$dirInfo{RAF};
@@ -693,9 +981,9 @@
     return 0 if $raf->Read($buff, 24) and ValidateICC(\$buff);
     # now write the new ICC
-    $buff = WriteICC_Profile($exifTool, $dirInfo);
+    $buff = WriteICC_Profile($et, $dirInfo);
     if (defined $buff and length $buff) {
         Write($$dirInfo{OutFile}, $buff) or return -1;
     } else {
-        $exifTool->Error('No ICC information to write');
+        $et->Error('No ICC information to write');
     }
     return 1;
@@ -710,14 +998,14 @@
 sub WriteICC_Profile($$;$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
     my $dirName = $$dirInfo{DirName} || 'ICC_Profile';
     # (don't write AsShotICCProfile or CurrentICCProfile here)
     return undef unless $dirName eq 'ICC_Profile';
-    my $nvHash = $exifTool->GetNewValueHash($Image::ExifTool::Extra{$dirName});
-    return undef unless Image::ExifTool::IsOverwriting($nvHash);
-    my $val = Image::ExifTool::GetNewValues($nvHash);
+    my $nvHash = $et->GetNewValueHash($Image::ExifTool::Extra{$dirName});
+    my $val = $et->GetNewValue($nvHash);
     $val = '' unless defined $val;
-    ++$exifTool->{CHANGED};
+    return undef unless $et->IsOverwriting($nvHash, $val);
+    ++$$et{CHANGED};
     return $val;
 }
@@ -747,5 +1035,5 @@
 sub ProcessICC($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $buff;
@@ -753,14 +1041,14 @@
     # check to see if this is a valid ICC profile file
     return 0 if ValidateICC(\$buff);
-    $exifTool->SetFileType();
+    $et->SetFileType();
     # read the profile
     my $size = unpack('N', $buff);
     if ($size < 128 or $size & 0x80000000) {
-        $exifTool->Error("Bad ICC Profile length ($size)");
+        $et->Error("Bad ICC Profile length ($size)");
         return 1;
     }
     $raf->Seek(0, 0);
-    unless ($raf->Read($buff, $size)) {
-        $exifTool->Error('Truncated ICC profile');
+    unless ($raf->Read($buff, $size) == $size) {
+        $et->Error('Truncated ICC profile');
         return 1;
     }
@@ -772,5 +1060,5 @@
     );
     my $tagTablePtr = GetTagTable('Image::ExifTool::ICC_Profile::Main');
-    return ProcessICC_Profile($exifTool, \%dirInfo, $tagTablePtr);
+    return ProcessICC_Profile($et, \%dirInfo, $tagTablePtr);
 }
 
@@ -782,18 +1070,19 @@
 sub ProcessICC_Profile($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
-    my $dirStart = $$dirInfo{DirStart};
+    my $dirStart = $$dirInfo{DirStart} || 0;
     my $dirLen = $$dirInfo{DirLen};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 
     return 0 if $dirLen < 4;
 
     # extract binary ICC_Profile data block if binary mode or requested
-    if ($exifTool->{OPTIONS}->{Binary} or $exifTool->{REQ_TAG_LOOKUP}->{icc_profile} and
+    if ((($$et{TAGS_FROM_FILE} and not $$et{EXCL_TAG_LOOKUP}{icc_profile}) or
+        $$et{REQ_TAG_LOOKUP}{icc_profile}) and
         # (don't extract from AsShotICCProfile or CurrentICCProfile)
         (not $$dirInfo{Name} or $$dirInfo{Name} eq 'ICC_Profile'))
     {
-        $exifTool->FoundTag('ICC_Profile', substr($$dataPt, $dirStart, $dirLen));
+        $et->FoundTag('ICC_Profile', substr($$dataPt, $dirStart, $dirLen));
     }
 
@@ -803,5 +1092,5 @@
     my $len = Get32u($dataPt, $dirStart);
     if ($len != $dirLen or $len < 128) {
-        $exifTool->Warn("Bad length ICC_Profile (length $len)");
+        $et->Warn("Bad length ICC_Profile (length $len)");
         return 0 if $len < 128 or $dirLen < $len;
     }
@@ -811,16 +1100,16 @@
         or $numEntries * 12 + 132 > $dirLen)
     {
-        $exifTool->Warn("Bad ICC_Profile table ($numEntries entries)");
+        $et->Warn("Bad ICC_Profile table ($numEntries entries)");
         return 0;
     }
 
     if ($verbose) {
-        $exifTool->VerboseDir('ICC_Profile', $numEntries, $dirLen);
+        $et->VerboseDir('ICC_Profile', $numEntries, $dirLen);
         my $fakeInfo = { Name=>'ProfileHeader', SubDirectory => { } };
-        $exifTool->VerboseInfo(undef, $fakeInfo);
+        $et->VerboseInfo(undef, $fakeInfo);
     }
     # increment ICC dir count
-    my $dirCount = $exifTool->{DIR_COUNT}->{ICC} = ($exifTool->{DIR_COUNT}->{ICC} || 0) + 1;
-    $exifTool->{SET_GROUP1} = '+' . $dirCount if $dirCount > 1;
+    my $dirCount = $$et{DIR_COUNT}{ICC} = ($$et{DIR_COUNT}{ICC} || 0) + 1;
+    $$et{SET_GROUP1} = '+' . $dirCount if $dirCount > 1;
     # process the header block
     my %subdirInfo = (
@@ -831,7 +1120,8 @@
         DirLen   => 128,
         Parent   => $$dirInfo{DirName},
+        DirName  => 'Header',
     );
     my $newTagTable = GetTagTable('Image::ExifTool::ICC_Profile::Header');
-    $exifTool->ProcessDirectory(\%subdirInfo, $newTagTable);
+    $et->ProcessDirectory(\%subdirInfo, $newTagTable);
 
     $pos += 4;    # skip item count
@@ -842,15 +1132,15 @@
         my $size   = Get32u($dataPt, $pos + 8);
         $pos += 12;
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tagID);
         # unknown tags aren't generated automatically by GetTagInfo()
         # if the tagID's aren't numeric, so we must do this manually:
-        if (not $tagInfo and $exifTool->{OPTIONS}->{Unknown}) {
+        if (not $tagInfo and $$et{OPTIONS}{Unknown}) {
             $tagInfo = { Unknown => 1 };
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tagID, $tagInfo);
+            AddTagToTable($tagTablePtr, $tagID, $tagInfo);
         }
         next unless defined $tagInfo;
 
         if ($offset + $size > $dirLen) {
-            $exifTool->Warn("Bad ICC_Profile table (truncated)");
+            $et->Warn("Bad ICC_Profile table (truncated)");
             last;
         }
@@ -880,8 +1170,8 @@
                     my $strLen = Get32u($dataPt, $recPos + 4);
                     my $strPos = Get32u($dataPt, $recPos + 8);
-                    last if $strPos + $strLen > $size; 
+                    last if $strPos + $strLen > $size;
                     my $str = substr($$dataPt, $valuePtr + $strPos, $strLen);
-                    $str = $exifTool->Decode($str, 'UTF16');
-                    $exifTool->HandleTag($tagTablePtr, $tagID, $str,
+                    $str = $et->Decode($str, 'UTF16');
+                    $et->HandleTag($tagTablePtr, $tagID, $str,
                         TagInfo => $langInfo || $tagInfo,
                         Table  => $tagTablePtr,
@@ -891,8 +1181,8 @@
                         Size   => $strLen,
                         Start  => $valuePtr + $strPos,
-                        Format => "type '$fmt'",
+                        Format => "type '${fmt}'",
                     );
                 }
-                $exifTool->Warn("Corrupted $$tagInfo{Name} data") if $i < $count;
+                $et->Warn("Corrupted $$tagInfo{Name} data") if $i < $count;
                 next;
             }
@@ -901,5 +1191,5 @@
         }
         $value = FormatICCTag($dataPt, $valuePtr, $size) unless $subdir;
-        $verbose and $exifTool->VerboseInfo($tagID, $tagInfo,
+        $verbose and $et->VerboseInfo($tagID, $tagInfo,
             Table  => $tagTablePtr,
             Index  => $index,
@@ -908,5 +1198,5 @@
             Size   => $size,
             Start  => $valuePtr,
-            Format => "type '$fmt'",
+            Format => "type '${fmt}'",
         );
         if ($subdir) {
@@ -930,4 +1220,5 @@
                 DirStart => $valuePtr,
                 DirLen   => $size,
+                DirName  => $name,
                 Parent   => $$dirInfo{DirName},
             );
@@ -935,18 +1226,18 @@
             #### eval Validate ($type)
             if (defined $$subdir{Validate} and not eval $$subdir{Validate}) {
-                $exifTool->Warn("Invalid $name data");
+                $et->Warn("Invalid ICC $name data");
             } else {
-                $exifTool->ProcessDirectory(\%subdirInfo, $newTagTable, $$subdir{ProcessProc});
+                $et->ProcessDirectory(\%subdirInfo, $newTagTable, $$subdir{ProcessProc});
             }
         } elsif (defined $value) {
-            $exifTool->FoundTag($tagInfo, $value);
+            $et->FoundTag($tagInfo, $value);
         } else {
             $value = substr($$dataPt, $valuePtr, $size);
             # treat unsupported formats as binary data
             $$tagInfo{ValueConv} = '\$val' unless defined $$tagInfo{ValueConv};
-            $exifTool->FoundTag($tagInfo, $value);
+            $et->FoundTag($tagInfo, $value);
         }
     }
-    delete $exifTool->{SET_GROUP1};
+    delete $$et{SET_GROUP1};
     return 1;
 }
@@ -974,5 +1265,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
